<?php

/**
 * @file
 * Views functionality for the recurring_events module.
 */

/**
 * Implements hook_views_data_alter().
 */
function recurring_events_views_data_alter(array &$data) {
  // Create a field to show the number of instances of an eventseries.
  $data['eventseries_field_data']['eventseries_instance_count'] = [
    'title' => t('Event series instance count'),
    'field' => [
      'title' => t('Event series instance count'),
      'help' => t('The number of event instances in a series.'),
      'id' => 'eventseries_instance_count',
    ],
  ];

  // Create a field to show the start date of an event series.
  $data['eventseries_field_data']['eventseries_start_date'] = [
    'title' => t('Event series start date'),
    'field' => [
      'title' => t('Event series start date'),
      'help' => t('The date on which an event first occurs.'),
      'id' => 'eventseries_start_date',
    ],
  ];

  // Set the default field for a view based on eventinstances.
  $data['eventinstance_field_data']['table']['base']['defaults']['field'] = 'id';

  // @todo Remove these declarations when
  // https://www.drupal.org/project/drupal/issues/2489476 is resolved.
  $data['eventinstance_field_data']['date__value']['filter']['id'] = 'datetime';
  $data['eventinstance_field_data']['date__value']['filter']['field_name'] = 'date';
  $data['eventinstance_field_data']['date__value']['sort']['id'] = 'datetime';
  $data['eventinstance_field_data']['date__value']['sort']['field_name'] = 'date';
  $data['eventinstance_field_data']['date__value']['argument']['id'] = 'datetime';
  $data['eventinstance_field_data']['date__value']['argument']['field_name'] = 'date';

  $data['eventinstance_field_data']['date__end_value']['filter']['id'] = 'datetime';
  $data['eventinstance_field_data']['date__end_value']['filter']['field_name'] = 'date';
  $data['eventinstance_field_data']['date__end_value']['sort']['id'] = 'datetime';
  $data['eventinstance_field_data']['date__end_value']['sort']['field_name'] = 'date';
  $data['eventinstance_field_data']['date__end_value']['argument']['id'] = 'datetime';
  $data['eventinstance_field_data']['date__end_value']['argument']['field_name'] = 'date';
}
